def find_closest(v, array):
    # Finds the closest value in an array for one given
    # value.
    import numpy as np

    diff = abs(array - v)
    index = np.argmin(diff)
    return index


def gaussian_filter(D,T,Fcentr,alpha):
    import numpy as np
    from scipy import signal, fftpack

    # Number of sample points & sample spacing
    N = len(D)
    dt = T[1]-T[0] 

    # Frequency
    D_freq = fftpack.rfft(D)
    fs = 1/(dt)
    freqs = fftpack.rfftfreq(N)*fs 

    # Gaussian
    gauss = np.exp(-alpha*((freqs-Fcentr)/Fcentr)**2)

    D_freq = D_freq*gauss    #(1+np.sign(freqs)) 

    # time-domain
    D_new = fftpack.irfft(D_freq) 
    return D_new


def envelope(data):
    import numpy as np
    from scipy.fftpack import hilbert
    """
    Envelope of a function.

    Computes the envelope of the given function. The envelope is determined by
    adding the squared amplitudes of the function and it's Hilbert-Transform
    and then taking the square-root. (See [Kanasewich1981]_)
    The envelope at the start/end should not be taken too seriously.

    :type data: numpy.ndarray
    :param data: Data to make envelope of.
    :return: Envelope of input data.

    (Taken from ObsPy source code)
    """
    hilb = hilbert(data)
    data = (data ** 2 + hilb ** 2) ** 0.5
    return data